import numpy as np

#step size
mu0=0.05

# data
apple = np.loadtxt("c:\\pytest\\chr_img.csv" ,delimiter=",")
teacher = np.loadtxt("c:\\pytest\\teacher.csv" ,delimiter=",")

# initial parameter value
wH = np.loadtxt("c:\\pytest\\wH.csv" ,delimiter=",")
wZ = np.loadtxt("c:\\pytest\\wO.csv" ,delimiter=",")
wZpure = wZ[0:4,1:4]

n0=501          #iterations number
n0_data=128     #data size

for j in range(n0):

    gradient_wH = np.zeros((3, 21))
    gradient_wZ = np.zeros((4, 4))
    target=0
    for i in range(n0_data):

        # Hidden layer
        sH = np.dot(apple[i], wH.T)
        h=np.reciprocal(1 + np.exp(-sH))

        # Output layer
        h1 = np.insert(h,0,-1)
        sZ = np.dot(h1, wZ.T)
        z = np.reciprocal(1 + np.exp(-sZ))

        #squae error
        target += np.sum((teacher[i] - z)**2)

        #delta
        deltaZ = -(teacher[i]-z)*z*(1-z)
        deltaH = np.dot(deltaZ, wZpure) * h * (1 - h)

        #gradient
        deltaH2 = deltaH.reshape(1,-1)
        apple2=apple[i].reshape(1,-1)
        gradient_wH1=np.dot(deltaH2.T , apple2)

        deltaZ2=deltaZ.reshape(1,-1)
        h2=h1.reshape(1,-1)
        gradient_wZ1=np.dot(deltaZ2.T , h2)

        gradient_wH += gradient_wH1 
        gradient_wZ += gradient_wZ1 

    print("j=",j,target)

    #parameter update
    wH -= mu0*gradient_wH 
    wZ -= mu0*gradient_wZ

print(wH)
print(wZ)

